<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * SugarCRM is a customer relationship management program developed by
 * SugarCRM, Inc. Copyright (C) 2004 - 2007 SugarCRM Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY SUGARCRM, SUGARCRM DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * 
 * You can contact SugarCRM, Inc. headquarters at 10050 North Wolfe Road,
 * SW2-130, Cupertino, CA 95014, USA. or at email address contact@sugarcrm.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * SugarCRM" logo. If the display of the logo is not reasonably feasible for
 * technical reasons, the Appropriate Legal Notices must display the words
 * "Powered by SugarCRM".
 ********************************************************************************/
require_once('modules/ACL/ACLController.php');

include('include/modules.php');
$default_actions = array();
$actions = array('view', 'edit', 'delete', 'list', 'import', 'export');
$default_deny = array('import'=>1,'export'=>1);
$default_owner = array('delete'=>1);
$db =& PearDatabase::getInstance();
$db->query("TRUNCATE acl_actions");
$db->query("TRUNCATE acl_roles");
$db->query("TRUNCATE acl_roles_actions");
$db->query("TRUNCATE acl_roles_users");
function acl_translate($access){
	switch($access){
		case ACL_ALLOW_ALL:
			return 'ALL';
		case ACL_ALLOW_OWNER:
			return 'OWNER';
		case ACL_ALLOW_NONE:
			return 'NONE';
		
	}
}
$testmodules = array('Accounts', 'Contacts', 'Users');
foreach($testmodules as $module){
	foreach($actions as $cur_action){
		$action = new ACLAction();
		$action->name = $cur_action;
		$action->category = $module;
		if(isset($default_owner[$cur_action])){
			$action->access = ACL_ALLOW_OWNER;
		}else if(isset($default_deny[$cur_action])){
			$action->access = ACL_ALLOW_NONE;
		}else{
				
			
			$action->access = ACL_ALLOW_ALL;
		}
		
		$action->save();
		
	}	

}

$action_results = ACLAction::getUserActions('will_id', true);
echo 'Actions Test no roles for will -access to all modules -owner delete and no import or export<br>';
foreach($action_results as $category_name=>$category){
	
	foreach($category as $action_name=>$action){
		_pp($category_name .':'. $action_name . ':' . acl_translate($action['access']));
		
	}
	
}

echo 'Create a role for Peon Users<br>';

$aclrole = new ACLRole();
$aclrole->name = 'Peon User';
$aclrole->description = 'The Peon Role For All Peons';
$aclrole->user_id = 'will_id';
$aclrole->save();

echo 'No Peon user should have access to accounts<br>';
foreach($action_results['Accounts'] as $action){
	$aclrole->setAction($aclrole->id, $action['id'], ACL_ALLOW_NONE);
}

echo 'Only owner Peon user should have editaccess to contacts<br>';

	$aclrole->setAction($aclrole->id, $action_results['Contacts']['edit']['id'], ACL_ALLOW_OWNER);
echo 'Some one made a mistake and added delete access on Contacts<br>';
$aclrole->setAction($aclrole->id, $action_results['Contacts']['delete']['id'], ACL_ALLOW_ALL);

$action_results = ACLAction::getUserActions('will_id', true);
echo 'Actions Peon role for will<br>';
foreach($action_results as $category_name=>$category){
	
	foreach($category as $action_name=>$action){
		_pp($category_name .':'. $action_name . ':' . acl_translate($action['access']));
		
	}
	
}
echo 'Will is a bad peon user<br>';
echo 'Create a role for Bad Peon Users<br>';
$aclrole = new ACLRole();
$aclrole->name = 'Bad Peon User';
$aclrole->description = 'The Bad Peon Role For All Bad Peons';
$aclrole->user_id = 'will_id';
$aclrole->save();

echo 'No Bad Peon user should have access to contacts <br>';
foreach($action_results['Contacts'] as $action){
	$aclrole->setAction($aclrole->id, $action['id'], ACL_ALLOW_NONE);
}
$action_results = ACLAction::getUserActions('will_id', true);
echo 'Actions Peon role for will<br>';
foreach($action_results as $category_name=>$category){
	
	foreach($category as $action_name=>$action){
		_pp($category_name .':'. $action_name . ':' . acl_translate($action['access']));
		
	}
	
}





echo 'PRINTING THE ACTIONS for a role <br>';
$role_actions = ACLRole::getRoleActions($aclrole->id);
_pp($role_actions);
echo 'PRINTING THE SESSION CACHE FOR ACL <br>';
_PP($_SESSION['ACL']);







?>
