/*********************************************************************************
 * SugarCRM is a customer relationship management program developed by
 * SugarCRM, Inc. Copyright (C) 2004 - 2007 SugarCRM Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY SUGARCRM, SUGARCRM DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * 
 * You can contact SugarCRM, Inc. headquarters at 10050 North Wolfe Road,
 * SW2-130, Cupertino, CA 95014, USA. or at email address contact@sugarcrm.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * SugarCRM" logo. If the display of the logo is not reasonably feasible for
 * technical reasons, the Appropriate Legal Notices must display the words
 * "Powered by SugarCRM".
 ********************************************************************************/
 if(typeof('console') == 'undefined'){
console = {
	log: function(message) {
	
	}
}
}
if(typeof(ModuleBuilder) == 'undefined'){
	ModuleBuilder = function(){
 		var center, north, east, west, south, mode;
		return {
			init : function(){
    	        // initialize state manager, we will use cookies
	            YAHOO.ext.state.Manager.setProvider(new YAHOO.ext.state.CookieProvider());
				
				ModuleBuilder.complexLayout = new YAHOO.ext.BorderLayout("mblayout", {
					hideOnLayout: true,
					center: {
						animate: false,
						autoScroll:false,
						tabPosition: 'top',
						collapsible: false,
						titlebar: true
					},
					west: {
						animate: false,
						autoScroll: true,
						collapsible: true,
						initialSize: 230,
						minSize: 100,
						split:true,
						tabPosition: 'top',
						useShim:true,
						titlebar: true
					},
					east: {
						animate: false,
						autoScroll: true,
						collapsible: true,
						initialSize: 250,
						minSize: 200,
						split:true,
						tabPosition: 'top',
						useShim:true,
						titlebar: true
					},
					south: {
						collapsible: false,
						collapsed: false,
						initialSize: 25,
						split:false,
						titlebar: true
					}

				});
				ModuleBuilder.complexLayout.beginUpdate();
				ModuleBuilder.complexLayout.add('center', ModuleBuilder.center = new YAHOO.ext.ContentPanel('mbcenter', SUGAR.language.get('ModuleBuilder', 'LBL_SECTION_MAIN')));
				ModuleBuilder.complexLayout.add('west', ModuleBuilder.west = new YAHOO.ext.ContentPanel('mbwest', SUGAR.language.get('ModuleBuilder', 'LBL_SECTION_PACKAGES')));
				ModuleBuilder.complexLayout.add('east', ModuleBuilder.east = new YAHOO.ext.ContentPanel('mbeast', SUGAR.language.get('ModuleBuilder', 'LBL_SECTION_PROPERTIES')));
				ModuleBuilder.complexLayout.add('east', ModuleBuilder.east2 = new YAHOO.ext.ContentPanel('mbeast2', SUGAR.language.get('ModuleBuilder', 'LBL_SECTION_DROPDOWNED')));
				ModuleBuilder.complexLayout.add('east', ModuleBuilder.help = new YAHOO.ext.ContentPanel('mbhelp', SUGAR.language.get('ModuleBuilder', 'LBL_SECTION_HELP')));
				ModuleBuilder.complexLayout.add('south', ModuleBuilder.south = new YAHOO.ext.ContentPanel('mbsouth', SUGAR.language.get('ModuleBuilder', 'LBL_SECTION_ACTION')));
				ModuleBuilder.complexLayout.showPanel('mbcenter');
				var east = ModuleBuilder.complexLayout.getRegion('east');
				east.tabs.activate('mbhelp');
				east.tabs.hideTab('mbeast');
				east.tabs.hideTab('mbeast2');
				//ModuleBuilder.complexLayout.restoreState();
				ModuleBuilder.complexLayout.endUpdate();
				if(typeof(YAHOO.widget.TreeView) !='undefined'){
					ModuleBuilder.treeSubscribe(YAHOO.widget.TreeView.trees.package_tree);
					ModuleBuilder.tree = YAHOO.widget.TreeView.trees.package_tree;
				}
                ModuleBuilder.south.setTitle(document.getElementById('footerHTML').innerHTML);
				ModuleBuilder.autoSetLayout();
				var west = ModuleBuilder.complexLayout.getRegion('west');
				if (ModuleBuilder.mode == 'mb') {
					west.updateTitle(SUGAR.language.get('ModuleBuilder', 'LBL_SECTION_PACKAGES'));
					ModuleBuilder.getContent('module=ModuleBuilder&action=package&package=');
				}
				else if (ModuleBuilder.mode == 'studio'){
					west.updateTitle(SUGAR.language.get('ModuleBuilder', 'LBL_SECTION_MODULES'));
					ModuleBuilder.getContent('module=ModuleBuilder&action=wizard');
				}







				else if (ModuleBuilder.mode == 'dropdowns')
				{
					west.updateTitle(SUGAR.language.get('ModuleBuilder', 'LBL_SECTION_DROPDOWNS'));
					ModuleBuilder.getContent('module=ModuleBuilder&action=dropdowns');
				}
				else {
					west.collapse();
					ModuleBuilder.getContent('module=ModuleBuilder&action=home');
				}
				Assistant.mbAssistant = Assistant.creatembAssistant();

		},
		setMode:function(reqMode) {
			ModuleBuilder.mode = reqMode;
		},
		main:function(type){
			document.location.href='index.php?module=ModuleBuilder&action=index&type=' + type;
		},
		failed:function(o){
			ajaxStatus.flashStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_FAILED_DATA'), 2000);
		},
		getBottom:function(el)
		{
			var bottom = YAHOO.ext.Element.get(el).getBottom();
			var divs = el.getElementsByTagName("DIV");
			for(var i=0;i<divs.length;i++)
			{
				var divEl = YAHOO.ext.Element.get(divs[i]);
				var float = (divEl.getStyle('cssFloat'));
				if (float != 'none') // only floated div's will have a bottom that is different from the containing div
				{
					var thisBottom = divEl.getBottom();
					bottom = isNaN(thisBottom) ? bottom : Math.max(bottom,thisBottom);
				}
			}

			return bottom;
		},
		updateContent:function(o){
			ajaxStatus.flashStatus('Done', 2000);
			ModuleBuilder.complexLayout.beginUpdate();
			var ajaxResponse = JSON.parse(o.responseText);
			for(var maj in ajaxResponse)
			{
				var name = 'mb' + maj;
				
				if(name=='mbwest'){ //refresh package_tree!
					var updatedTree;
					treeinit(updatedTree, ajaxResponse.west.content.tree_data, 'package_tree',ajaxResponse.west.content.param);
					ModuleBuilder.tree=null;
					ModuleBuilder.tree = YAHOO.widget.TreeView.trees.package_tree;
					ModuleBuilder.treeSubscribe(ModuleBuilder.tree);	
				}
				else
				{
					var el = document.getElementById(name);
					if(el != null)
					{
						switch(maj)
						{
							case 'help':
							case 'east2':
							case 'east':
								var panel = ModuleBuilder.complexLayout.getRegion('east');
								break;
							default:
								var panel = ModuleBuilder.complexLayout.getRegion(maj);
						}
						
						var currentHeight = ModuleBuilder.complexLayout.getEl().getHeight();
						el.innerHTML = "<div class='bodywrapper'><div>" + ajaxResponse[maj].crumb + "</div>" + ajaxResponse[maj].content + "</div>";
						SUGAR.util.evalScript(el.innerHTML);
						
						// now adjust the height of the layout
						// we want the height to be that of the tallest of west, east and center + heights of north and south + a padding
						if ( maj == 'center')
						{
							var oldBottom = ModuleBuilder.complexLayout.getRegion('west').getEl().getBottom();
							//var eastHeight = ModuleBuilder.complexLayout.getRegion('east').getEl().getHeight();
							//var layoutBottom = ModuleBuilder.complexLayout.getEl().getBottom();
							//var oldCenterHeight = Math.max(westHeight,eastHeight,currentHeight); 
							var newBottom = ModuleBuilder.getBottom(el) + 100; // add a bit of padding

							var delta = newBottom-oldBottom;
							if ((delta<0) && (delta>-100)) // if the size has only gone down by 100 then don't bother resizing...
							{
								delta = 0;
							}
							ModuleBuilder.complexLayout.getEl().setHeight(Math.max(currentHeight+delta,700));
						}
						
						switch(ajaxResponse[maj].action){
							case 'activate':
									//only east and help can be activated and deactivated
									switch(maj){
										case 'help':
										case 'east':
										case 'east2':
											panel.tabs.unhideTab(name);
											panel.tabs.activate(name);
										default:
										panel.show();
										panel.expand();	
									}
									break;
							case 'deactivate':
									//only east can be deactivated
									switch(maj){
										case 'east':
											panel.tabs.activate('mbhelp');
											panel.tabs.hideTab(name);
											break;
										case 'east2':
											if(panel.tabs.items['mbeast'].hidden){
												panel.tabs.activate('mbhelp');
											}else{
												panel.tabs.activate('mbeast');
											}
											panel.tabs.hideTab(name);
											break;
									}
						
						}
						if(ajaxResponse[maj].title && ajaxResponse[maj].title != 'no_change'){
							panel.updateTitle(ajaxResponse[maj].title);
						}
					}
				}
			ModuleBuilder.complexLayout.endUpdate();
			}
		},
		hidePropertiesTab:function(){
			var panel = ModuleBuilder.complexLayout.getRegion('east');
			panel.tabs.activate('mbhelp');
			panel.tabs.hideTab('mbeast');
			panel.tabs.hideTab('mbeast2');
			
		},
		getContent:function(url, successCall){
			if(ModuleBuilder.callLock){
				ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_TIME_DEPENDENT'));
				return;
			}
			ajaxStatus.showStatus('Loading...');
			var callback = {success:ModuleBuilder.updateContent, failure:ModuleBuilder.failed}; 
			if(typeof(successCall) != 'undefined'){
				callback['success'] = successCall;
				ModuleBuilder.callLock = true;
			}
			YAHOO.util.Connect.asyncRequest('POST', 'index.php', callback, url + '&to_pdf=true'); 
		},
		submitForm:function(formname, successCall){
			
			if(ModuleBuilder.callLock){
				ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_TIME_DEPENDENT'));
				return;
			}
			ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_LOADING'));
			if(typeof(successCall) == 'undefined'){
				successCall = ModuleBuilder.updateContent;
			}else{
				ModuleBuilder.callLock = true;
			}
			var callback = {success:successCall, failure:ModuleBuilder.failed};
			var formObject = eval('document.' + formname);
			YAHOO.util.Connect.setForm(formObject); 
			YAHOO.util.Connect.asyncRequest('POST', 'index.php', callback); 
		
		},
		submitUpload:function(formname,uploadCall){
			
			if(ModuleBuilder.callLock){
				ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_TIME_DEPENDENT'));
				return;
			}
			ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_LOADING'));
			var formObject = eval('document.' + formname);
			YAHOO.util.Connect.setForm(formObject,true,true); 
//			YAHOO.util.Connect.setForm(formObject,true); 
			YAHOO.util.Connect.asyncRequest('POST', 'index.php', {upload:uploadCall}); 
		
		},
		buttonDown:function(button,name,list){
			if(typeof(name) != 'undefined'){
				for(i in ModuleBuilder.buttons[list]){
					ModuleBuilder.buttons[list][i].className = 'wizardButton';
				}
				ModuleBuilder.buttonSelect(name, list);
			}
			button.className='wizardButtonDown';
			
		},
		buttonOver:function(button){
			button.className = 'buttonOn';
		},
		buttonOut:function(button, name, list){
			if(typeof(name) != 'undefined'){
				if(ModuleBuilder.buttonGetSelected(list) != name){
					button.className = 'wizardButton'
				}
			}else{
				button.className = 'wizardButton'
			}
			
		},
		buttonAdd:function(id,name, list){
			if(typeof(ModuleBuilder.buttons[list]) == 'undefined'){
				ModuleBuilder.buttons[list] = {};
				
			}
		    ModuleBuilder.buttons[list][name] = document.getElementById(id);
		    
		},
		buttonGetSelected:function(list){
			if(typeof(ModuleBuilder.selected[list]) == 'undefined'){
				return false;
			}
			return ModuleBuilder.selected[list];
		},
		buttonSelect:function(name, list){
			ModuleBuilder.selected[list] = name;
		},
		buttonToForm:function(form, field, list){
			var theField = eval('document.' + form  + '.' + field);
			theField.value = ModuleBuilder.buttonGetSelected(list);
		},
		treeSubscribe:function(tree){
			tree.subscribe("labelClick", ModuleBuilder.treeLabelClick); 
		}, 
		treeLabelClick:function(node){
			if( node.data.action){
				ModuleBuilder.getContent(node.data.action);
			}
		},
		treeRefresh:function(type){
			ModuleBuilder.getContent('module=ModuleBuilder&action=ViewTree&tree=' + type);
		},
		getTitle:function(title, breadCrumb){
			return "<h2>" + title + "</h2><br>"+ breadCrumb;
			
		},
		helpRegister:function(name){
			var formname = 'document.' + name;
			var form = eval(formname);
			var i = 0;
			for(i=0; i < form.elements.length; i++){
				if(typeof(form.elements[i].type) != 'undefined' && typeof(form.elements[i].name) != 'undefined' && form.elements[i].type != 'hidden'){
						form.elements[i].onmouseover = function(){ModuleBuilder.helpToggle(this.name)};
						form.elements[i].onmouseout = function(){ModuleBuilder.helpToggle('default')};
					
				}
			}
		},
		helpRegisterByID:function(name, tag){
			var parent = document.getElementById(name);
			var children = parent.getElementsByTagName(tag);
			for(var i=0; i < children.length; i++){
				if(children[i].id != 'undefined'){
					children[i].onmouseover = function(){ModuleBuilder.helpToggle(this.id)};
					//children[i].onmouseover = function(){alert(this.id)};
					children[i].onmouseout = function(){ModuleBuilder.helpToggle('default')};
				}
			}
		}, 
		helpSetup:function(group, def){
		 	var helpLang = SUGAR.language.get('ModuleBuilder', 'help');
		 	ModuleBuilder.helpLang = helpLang[group];
		 	ModuleBuilder.helpDefault = def;
		 	ModuleBuilder.helpToggle('default');
		},
		helpSetupAssistant:function(group, subgroup ){
			helpLang=SUGAR.language.get('ModuleBuilder','assistantHelp');
			
		},
			
		helpToggle:function(name){
			if(name == 'default')name = ModuleBuilder.helpDefault;
			if(ModuleBuilder.helpLang!=null && typeof(ModuleBuilder.helpLang[name]) != 'undefined'){
				document.getElementById('mbhelp').innerHTML = ModuleBuilder.helpLang[name];
			}
		}, 
		handleSave:function(form, callBack){
			if(check_form(form)){
				ModuleBuilder.submitForm(form, callBack);
			}
			
		}, 
		addModule:function(MBpackage){
			ModuleBuilder.getContent('module=ModuleBuilder&action=module&view_package=' + MBpackage);
		},
		viewModule:function(MBpackage, module){
			ModuleBuilder.getContent('module=ModuleBuilder&action=module&view_package=' + MBpackage + '&view_module=' + module);
		},
		packageDelete:function(MBpackage){
			ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_DELETING'));
			if(confirm(SUGAR.language.get('ModuleBuilder', 'LBL_JS_REMOVE_PACKAGE'))){
				ModuleBuilder.getContent('module=ModuleBuilder&action=DeletePackage&package=' + MBpackage);
				ModuleBuilder.tree.removeNode(ModuleBuilder.tree.getNodeByProperty('id', 'package_tree/'+ MBpackage), true);
				ModuleBuilder.tree.draw();
			}
		},
		packagePublish:function(form){
			if(check_form(form)){
				ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_BUILDPROGRESS'));
				ModuleBuilder.submitForm(form, ModuleBuilder.packageBuild);	
			}
		},
		packageBuild:function(o){
			//make sure no user changes were made
			document.CreatePackage.action.value='BuildPackage';
			document.CreatePackage.submit();
			ModuleBuilder.callLock = false;
		},
		packageDeploy:function(form){
			if(check_form(form)){
				ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_DEPLOYPROGRESS'));
				ModuleBuilder.submitForm(form, ModuleBuilder.packageInstall);	
			}
		},
		packageInstall:function(o){
			//make sure no user changes were made
			document.CreatePackage.action.value='displaydeploy';
			ModuleBuilder.callLock = false;
			ModuleBuilder.submitForm('CreatePackage');	
			
		},
		beginDeploy: function(package){
			var callback = {success:ModuleBuilder.deployComplete, failure:ModuleBuilder.failed};
			YAHOO.util.Connect.asyncRequest('GET', 'index.php?module=ModuleBuilder&action=DeployPackage&package='+package+'&to_pdf=1', callback, null);
		},
		deployComplete: function(data){
			ModuleBuilder.getContent('module=ModuleBuilder&action=package&package=');
			YAHOO.util.Connect.asyncRequest('GET', 'index.php?module=Administration&action=RebuildRelationship&silent=true', null, null);
		}, 
		packageExport:function(form){
			if(check_form(form)){
				ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_BUILDPROGRESS'));
				ModuleBuilder.submitForm(form, ModuleBuilder.packageExportProject);	
			}
		},
		packageExportProject:function(o){
			//make sure no user changes were made
			document.CreatePackage.action.value='ExportPackage';
			document.CreatePackage.submit();
			ModuleBuilder.callLock = false;
		},
		moduleDelete:function(MBpackage, module){
			ajaxStatus.showStatus(SUGAR.language.get('ModuleBuilder', 'LBL_AJAX_DELETING'));
			if(confirm(SUGAR.language.get('ModuleBuilder', 'LBL_JS_REMOVE_PACKAGE'))){
				ModuleBuilder.getContent('module=ModuleBuilder&action=DeleteModule&package=' + MBpackage + '&view_module='+ module);
				ModuleBuilder.tree.removeNode(ModuleBuilder.tree.getNodeByProperty('id', MBpackage + '/' + module), true);
				ModuleBuilder.tree.draw();
			}
		},
		moduleViewFields:function(o){
				
				ModuleBuilder.callLock = false;
				
				ModuleBuilder.getContent('module=ModuleBuilder&action=modulefields&view_package=' + ModuleBuilder.MBpackage + '&view_module='+ ModuleBuilder.module);
		}, 
		moduleLoadField:function(name, type){
				if(typeof(type) == 'undefined')type = 0;
				if(typeof(formsWithFieldLogic)!='undefined') formsWithFieldLogic='undefined'; 
				ModuleBuilder.getContent('module=ModuleBuilder&action=modulefield&view_package=' + ModuleBuilder.MBpackage + '&view_module='+ ModuleBuilder.module+'&field=' + name + '&type=' + type);
		},
		moduleLoadLabels:function(type){
			if(typeof(type) == 'undefined')type = 0;
			else if(type=="studio"){
				ModuleBuilder.getContent('module=ModuleBuilder&action=editLabels&editModule='+ModuleBuilder.module);
			}
			else if(type=="mb"){
				ModuleBuilder.getContent('module=ModuleBuilder&action=modulelabels&view_package=' + ModuleBuilder.MBpackage + '&view_module='+ ModuleBuilder.module+ '&type=' + type);
			}
		},
		moduleViewRelationships:function(o){
				ModuleBuilder.callLock = false;
				ModuleBuilder.getContent('module=ModuleBuilder&action=relationships&view_package=' + ModuleBuilder.MBpackage + '&view_module='+ ModuleBuilder.module);
		}, 
		moduleLoadRelationship:function(name, type){
				if(typeof(type) == 'undefined')type = 0;
				//console.log('module=ModuleBuilder&action=relationship&view_package=' + ModuleBuilder.MBpackage + '&view_module='+ ModuleBuilder.module+'&name=' + name + '&relate=' + type);
				ModuleBuilder.getContent('module=ModuleBuilder&action=relationship&view_package=' + ModuleBuilder.MBpackage + '&view_module='+ ModuleBuilder.module+'&name=' + name + '&relate=' + type);
		},
		moduleDropDown:function(name, field){
				ModuleBuilder.getContent('module=ModuleBuilder&action=dropdown&view_package=' + ModuleBuilder.MBpackage + '&view_module='+ ModuleBuilder.module+'&dropdown_name=' + name+'&field=' + field );	
		},
		moduleViewLayouts:function(o){
                ModuleBuilder.callLock = false;
                ModuleBuilder.getContent('module=ModuleBuilder&MB=1&action=wizard&package=' + ModuleBuilder.MBpackage + '&editModule='+ ModuleBuilder.module);
        },
		autoSetLayout:function() {
			var c = document.getElementById('mblayout');
			var nav = new String(navigator.appVersion);
			var cH = c.offsetTop;
			//var h = (nav.match(/MSIE/i)) ? window.screen.availHeight : document.body.scrollHeight;
			var h = (nav.match(/MSIE/i)) ? document.body.clientHeight - 10 : document.body.scrollHeight - 10;
			c.style.height = h - cH;
			ModuleBuilder.complexLayout.layout();
		//debugger;
	},
	refreshGlobalDropDown: function(o)
	{
		// just clear the callLock; the convention is that this is done in a handler rather than in updateContent
		ModuleBuilder.callLock = false;
		ModuleBuilder.updateContent(o);
	},
	 refreshDropDown: function(){
	 	ModuleBuilder.callLock = false;
    	document.popup_form.action.value='RefreshField';
    	document.popup_form.new_dropdown.value= ModuleBuilder.refreshDD_name;
    	SimpleList.refreshDD_name = '';
    	ModuleBuilder.submitForm("popup_form");
    },
     dropdownChanged: function(value){
	    if(typeof(app_list_strings[value]) == 'undefined')return;
	    var select = document.getElementById('default').options;
	    select.length = 0;
	
	    var count = 0;
	    for(var key  in app_list_strings[value]){
	        select[count] = new Option(app_list_strings[value][key], key);
	        count++;
    }
}
}

}();
ModuleBuilder.buttons = {};
ModuleBuilder.selected = {};
ModuleBuilder.callLock = false;
YAHOO.ext.EventManager.onWindowResize(ModuleBuilder.autoSetLayout);
}

Assistant={
		
		processUserPref:function(value){
			if(value=='ENABLED' || value=="na"){
				Assistant.mbAssistant.visible=true;
				Assistant.mbAssistant.setFooter(Assistant.showOnFooter);
			}
			else if(value=='DISABLED'){
				Assistant.mbAssistant.visible=false;
				Assistant.mbAssistant.setFooter(Assistant.showOffFooter);
			}
			
		},
		showOffFooter: '<span> <form> <input id = "_assistantPref_" type="hidden" value = "show" /><a href="#" onclick="Assistant.submitForm();">' + SUGAR.language.get('ModuleBuilder', 'LBL_AS_SHOW') + '</form></span>',
		showOnFooter: '<span> <form> <input id = "_assistantPref_" type="hidden" value = "ignore" /><a href="#" onclick="Assistant.submitForm();">' + SUGAR.language.get('ModuleBuilder', 'LBL_AS_IGNORE') + '</form></span>',
		creatembAssistant: function(){
			var mbAssistant = new YAHOO.widget.Panel("panel2",{
				width:"400px",
				close:true,
				visible:false,
				draggable:true,
				constraintoviewport :true,		
				iframe:true,
				x:500,
				y:400,
				zindex:999999
				//effect: {effect: YAHOO.widget.ContainerEffect.FADE, duration:0.5}
				         
			});
			mbAssistant.setHeader("<div class='tl'></div><span>" + SUGAR.language.get('ModuleBuilder', 'LBL_AS_SAYS') + "</span><div class='tr'></div>");
			mbAssistant.setBody('');//Welcome to the Developer Tools area.  Use the tools within this area to create and manage standard and custom modules and fields. <br/><br/>To manage existing modules, click <h1>Studio</h1>.<br/><br/> To create custom modules, click <h1>Module Builder</h1>.');
			mbAssistant.setFooter(this.showOnFooter);
			mbAssistant.render(document.body);
			
			return mbAssistant ;
		},

		submitForm: function(){
			if(Assistant.mbAssistant)
				Assistant.mbAssistant.hide();
			var request;
			var params= 'pref_value='+document.getElementById('_assistantPref_').value;
			params+='&action=saveAssistantPref';
			params+='&module=ModuleBuilder';
			params+='&to_pdf=1';
			try{
				request=new XMLHttpRequest();
			}catch( error ){
				try{
				  request=new ActiveXObject("Microsoft.XMLHTTP");
				} catch(error){
					return true;
				}
			}
			
			request.open('post','index.php',true);
			request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			request.setRequestHeader("Content-length", params.length);
			request.onreadystatechange = function(){
				if(request.readyState == 4){
					if(request.status && /200|304/.test(request.status)){
						eval(request.responseText);
						return;
					} else{
						ModuleBuilder.failed(request);
					}
				}
			}
			request.send(params);
			return false;
		}
		
		
	}
