<?php
/*********************************************************************************
 * SugarCRM is a customer relationship management program developed by
 * SugarCRM, Inc. Copyright (C) 2004 - 2007 SugarCRM Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY SUGARCRM, SUGARCRM DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * 
 * You can contact SugarCRM, Inc. headquarters at 10050 North Wolfe Road,
 * SW2-130, Cupertino, CA 95014, USA. or at email address contact@sugarcrm.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * SugarCRM" logo. If the display of the logo is not reasonably feasible for
 * technical reasons, the Appropriate Legal Notices must display the words
 * "Powered by SugarCRM".
 ********************************************************************************/

require_once ('modules/ModuleBuilder/parsers/parser.buildsubpanel.php');

class ParserBuildLocalSubpanelParser extends ParserBuildSubPanel
{
	
	function init ($module_name, $subpanelName)
	{
		$this->package = isset($_REQUEST ['package']) ? $_REQUEST ['package'] : '';
		$this->parent_module = $module_name;
		$this->child_module = $subpanelName;
		
		//get the bean from ModuleBuilder
		$mb = new ModuleBuilder();
		$mod = & $mb->getPackageModule($this->package, $module_name);
		$mod->mbvardefs->updateVardefs();
		
		$subpanel_layout = $mod->getAvailibleSubpanelDef($subpanelName);
		$this->focus = $mod;
		
		$this->originalListViewDefs = array();
		foreach ($mod->config ['templates'] as $temp => $key)
		{
			$orig = MB_TEMPLATES . '/' . $temp . '/metadata/listviewdefs.php';
			if (file_exists($orig))
			{
				include ($orig);
				$this->originalListViewDefs = & $listViewDefs ['<module_name>'];
			}
		}
		$this->original_list_fields = & $subpanel_layout ['list_fields'];
		$this->language_module = '';
		global $mod_strings;
		$mod_strings = array_merge($mod_strings, $mod->getModStrings());
		//_ppd($mod->getModStrings());
		$this->list_fields = $this->original_list_fields;
		$this->panelFieldDefs = $mod->mbvardefs->vardefs ['fields'];
	}
	
	function handleSave ()
	{
		$subpanel_layout = $this->focus->getAvailibleSubpanelDef($this->child_module);
		foreach ($_REQUEST ['group_0'] as $field)
		{
			if (! empty($this->original_list_fields [$field]))
			{
				$newFields [$field] = $this->original_list_fields [$field];
			} else
			{
				$vname = '';
				if (isset($this->panelFieldDefs [$field]))
				{
					$vname = $this->panelFieldDefs [$field] ['vname'];
				}
				
				if (isset($mod->field_name_map [$field]) && ($mod->field_name_map [$field] ['type'] == 'bool' || (isset($mod->field_name_map [$field] ['custom_type']) && $mod->field_name_map [$field] ['custom_type'] == 'bool')))
				{
					$newFields [$field] = array('name' => $field, 'vname' => $vname, 'widget_type' => 'checkbox');
				} else
				{
					$newFields [$field] = array('name' => $field, 'vname' => $vname);
				}
			}
			
			if (isset($_REQUEST [strtolower($field) . 'width']))
			{
				$width = substr($_REQUEST [strtolower($field) . 'width'], 6, 3);
				if (strpos($width, "%") != false)
				{
					$width = substr($width, 0, 2);
				}
				if ($width < 101 && $width > 0)
				{
					$newFields [$field] ['width'] = $width;
				}
			} else if (isset($this->panelFieldDefs [$field] ['width']))
			{
				$newFields [$field] ['width'] = $this->panelFieldDefs [$field] ['width'];
			} else if (! isset($newFields [$field] ['width']))
			{
				$newFields [$field] ['width'] = '10';
			}
		}
		$dirname = $this->focus->getModuleDir() . "/metadata/subpanels/";
		if (! is_dir($dirname))
		{
			mkdir_recursive($dirname, true);
		}
		$filename = $dirname . $this->child_module . ".php";
		$subpanel_layout ['list_fields'] = $newFields;
		if (! write_array_to_file("subpanel_layout", $subpanel_layout, $filename))
		{
			_ppd("Could not write $filename");
		}
		//$this->subpanel->saveSubPanelDefOverride( $this->panelFieldDefs,'list_fields', $newFields);
	//save the new subpanel
	}
}

?>
